// NMT_ProtocolDlg.cpp : implementation file
//

#include "stdafx.h"
#include "NMT_Protocol.h"
#include "NMT_ProtocolDlg.h"
#include "..\lib\i7565cpm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CNMT_ProtocolDlg dialog

CNMT_ProtocolDlg::CNMT_ProtocolDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CNMT_ProtocolDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CNMT_ProtocolDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CNMT_ProtocolDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CNMT_ProtocolDlg)
	DDX_Control(pDX, IDC_LIST_EMCYLIST, m_reslist);
	DDX_Control(pDX, IDC_EDIT_LIFETIME, m_lifetime);
	DDX_Control(pDX, IDC_EDIT_HEARTBEAT, m_heartbeat);
	DDX_Control(pDX, IDC_EDIT_GUARDTIME, m_guardtime);
	DDX_Control(pDX, IDC_EDIT_CONSUMER, m_consumer);
	DDX_Control(pDX, IDC_COMBO_STATUS, m_status);
	DDX_Control(pDX, IDC_COMBO_NODE, m_node);
	DDX_Control(pDX, IDC_COMBO_COM, m_comport);
	DDX_Control(pDX, IDC_COMBO_BAUD, m_baud);
	DDX_Control(pDX, IDC_BUTTON_SHUTDOWN, m_btn_shutdown);
	DDX_Control(pDX, IDC_BUTTON_SETSTATE, m_btn_setstate);
	DDX_Control(pDX, IDC_BUTTON_REMOVE, m_btn_removenode);
	DDX_Control(pDX, IDC_BUTTON_INITIAL, m_btn_initial);
	DDX_Control(pDX, IDC_BUTTON_HEARTBEAT, m_btn_heartbeat);
	DDX_Control(pDX, IDC_BUTTON_GUARDING, m_btn_guarding);
	DDX_Control(pDX, IDC_BUTTON_CLEAR, m_btn_clear);
	DDX_Control(pDX, IDC_BUTTON_ADDNODE, m_btn_addnode);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CNMT_ProtocolDlg, CDialog)
	//{{AFX_MSG_MAP(CNMT_ProtocolDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_CBN_SELCHANGE(IDC_COMBO_COM, OnSelchangeComboCom)
	ON_CBN_SELCHANGE(IDC_COMBO_BAUD, OnSelchangeComboBaud)
	ON_CBN_SELCHANGE(IDC_COMBO_NODE, OnSelchangeComboNode)
	ON_CBN_SELCHANGE(IDC_COMBO_STATUS, OnSelchangeComboStatus)
	ON_BN_CLICKED(IDC_BUTTON_INITIAL, OnButtonInitial)
	ON_BN_CLICKED(IDC_BUTTON_SHUTDOWN, OnButtonShutdown)
	ON_BN_CLICKED(IDC_BUTTON_ADDNODE, OnButtonAddnode)
	ON_BN_CLICKED(IDC_BUTTON_REMOVE, OnButtonRemove)
	ON_BN_CLICKED(IDC_BUTTON_SETSTATE, OnButtonSetstate)
	ON_BN_CLICKED(IDC_BUTTON_GUARDING, OnButtonGuarding)
	ON_BN_CLICKED(IDC_BUTTON_HEARTBEAT, OnButtonHeartbeat)
	ON_BN_CLICKED(IDC_BUTTON_CLEAR, OnButtonClear)
	ON_WM_DESTROY()
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CNMT_ProtocolDlg message handlers

BYTE COMPORT=0;
BYTE BAUD=0;
BYTE NODE=1;
BYTE STA=0x01;

BYTE BlockMode = 1;

CString STA_Str;
CString NMTErr;
CString EMCY;

WORD DelayTime=0;
WORD ret;
CString errstr;

void CNMT_ProtocolDlg::Enable_Disable(bool Sta)
{
	if(Sta == FALSE){
		m_status.EnableWindow(FALSE);
		m_btn_setstate.EnableWindow(FALSE);
		m_btn_removenode.EnableWindow(FALSE);
		m_btn_guarding.EnableWindow(FALSE);
		m_btn_heartbeat.EnableWindow(FALSE);
		m_btn_clear.EnableWindow(FALSE);
		m_guardtime.EnableWindow(FALSE);
		m_lifetime.EnableWindow(FALSE);
		m_heartbeat.EnableWindow(FALSE);
		m_consumer.EnableWindow(FALSE);
	}
	else{
		m_status.EnableWindow(TRUE);
		m_btn_setstate.EnableWindow(TRUE);
		m_btn_removenode.EnableWindow(TRUE);
		m_btn_guarding.EnableWindow(TRUE);
		m_btn_heartbeat.EnableWindow(TRUE);
		m_btn_clear.EnableWindow(TRUE);
		m_guardtime.EnableWindow(TRUE);
		m_lifetime.EnableWindow(TRUE);
		m_heartbeat.EnableWindow(TRUE);
		m_consumer.EnableWindow(TRUE);
	}
}

BOOL CNMT_ProtocolDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

	STA_Str.Format(_T("Operation mode"));

	m_comport.EnableWindow(TRUE);
	m_baud.EnableWindow(TRUE);
	m_node.EnableWindow(FALSE);

	m_btn_initial.EnableWindow(TRUE);
	m_btn_initial.ShowWindow(SW_SHOW);
	m_btn_shutdown.EnableWindow(TRUE);
	m_btn_shutdown.ShowWindow(SW_HIDE);
	m_btn_addnode.EnableWindow(FALSE);
	m_btn_addnode.ShowWindow(SW_SHOW);
	m_btn_removenode.EnableWindow(FALSE);
	m_btn_removenode.ShowWindow(SW_HIDE);

	Enable_Disable(FALSE);

	m_comport.SetCurSel(0);
	m_baud.SetCurSel(0);
	m_node.SetCurSel(0);
	m_status.SetCurSel(0);

	m_guardtime.LimitText(5);
	m_lifetime.LimitText(3);
	m_heartbeat.LimitText(5);
	m_consumer.LimitText(5);

	m_guardtime.SetWindowText(_T("1000"));
	m_lifetime.SetWindowText(_T("2"));
	m_heartbeat.SetWindowText(_T("1000"));
	m_consumer.SetWindowText(_T("2500"));

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CNMT_ProtocolDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CNMT_ProtocolDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CNMT_ProtocolDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

BOOL CNMT_ProtocolDlg::PreTranslateMessage(MSG* pMsg)	// Overload PreTranslateMessage
{
	if(pMsg->message == WM_CHAR){	// Check "WM_CHAR" message
		if((pMsg->hwnd == m_guardtime.m_hWnd)||(pMsg->hwnd == m_lifetime.m_hWnd)||(pMsg->hwnd == m_heartbeat.m_hWnd)||(pMsg->hwnd == m_consumer.m_hWnd)){
			if(((pMsg->wParam >= 0x30)&&(pMsg->wParam <= 0x39))||(pMsg->wParam == 0x08)){
				return FALSE;	// pass "0 ~ 9" and "Back"
			}
			else{
				return TRUE;
			}
		}
	}

	return FALSE;
}

void CNMT_ProtocolDlg::OnSelchangeComboCom() 
{
	// TODO: Add your control notification handler code here
	COMPORT = m_comport.GetCurSel();
}

void CNMT_ProtocolDlg::OnSelchangeComboBaud() 
{
	// TODO: Add your control notification handler code here
	BAUD = m_baud.GetCurSel();
	
	switch(BAUD){
	case 0:
		DelayTime = 15;
		break;
	case 1:
		DelayTime = 7;
		break;
	case 2:
		DelayTime = 3;
		break;
	case 3:
	case 4:
		DelayTime = 1;
		break;
	case 5:
	case 6:
	case 7:
		DelayTime = 0;
		break;
	}
}

void CNMT_ProtocolDlg::OnSelchangeComboNode() 
{
	// TODO: Add your control notification handler code here
	NODE = m_node.GetCurSel()+1;
}

void CNMT_ProtocolDlg::OnSelchangeComboStatus() 
{
	// TODO: Add your control notification handler code here
	switch(m_status.GetCurSel()){
	case 0:		// Operation mode
		STA = 0x01;
		STA_Str = "Operation mode";
		break;
	case 1:		// Stop mode
		STA = 0x02;
		STA_Str = "Stop mode";
		break;
	case 2:		// Pre-Operation mode
		STA = 0x80;
		STA_Str = "Pre-Operation mode";
		break;
	case 3:		// Reset Node
		STA = 0x81;
		STA_Str = "Reset Node";
		break;
	case 4:		// Reset Communication
		STA = 0x82;
		STA_Str = "Reset Communication";
		break;
	}
}

void UserNMTErrISR() 
{
	WORD Ret;
	BYTE ComPortNo, Node, Mode;
	NMTErr = "";

	Ret = I7565CPM_GetNMTError(&ComPortNo, &Node, &Mode);
	if(!Ret){
		if(Mode == CPM_Node_Guarding_Event){
			NMTErr.Format(_T("Node %d Guarding Error"),Node);
		}
		else if(Mode == CPM_Heartbeat_Event){
			NMTErr.Format(_T("Node %d Heartbeat Error"),Node);
		}
	}
}

void UserEMCYISR() 
{
	BYTE ComPortNo, Node, Data[8];
	WORD Ret;
	EMCY = "";

	Ret = I7565CPM_GetEMCYData(&ComPortNo, &Node, Data);
	if(!Ret){
		EMCY.Format(_T("EMCY Node %d: %02X %02X %02X %02X %02X %02X %02X %02X"),Node,
			Data[0],Data[1],Data[2],Data[3],Data[4],Data[5],Data[6],Data[7]);
	}
}

void CNMT_ProtocolDlg::OnButtonInitial() 
{
	// TODO: Add your control notification handler code here
	ret = I7565CPM_InitMaster(COMPORT, 0, BAUD, BlockMode);
	if(ret){
		errstr.Format(_T("Initial Error, = %d"),ret);
		MessageBox(errstr,_T("Error"),MB_OK);
	}
	else{
		I7565CPM_InstallNMTErrISR(COMPORT,UserNMTErrISR);
		I7565CPM_InstallEMCYISR(COMPORT,UserEMCYISR);

		m_comport.EnableWindow(FALSE);
		m_baud.EnableWindow(FALSE);
		m_node.EnableWindow(TRUE);

		m_btn_initial.ShowWindow(SW_HIDE);
		m_btn_shutdown.ShowWindow(SW_SHOW);
		m_btn_addnode.EnableWindow(TRUE);

		SetTimer(123,100,NULL);
	}
}

void CNMT_ProtocolDlg::OnButtonShutdown() 
{
	// TODO: Add your control notification handler code here
	ret = I7565CPM_ShutdownMaster(COMPORT);
	if(ret){
		errstr.Format(_T("Shutdown Error, = %d"),ret);
		MessageBox(errstr,_T("Error"),MB_OK);
	}
	else{
		I7565CPM_RemoveNMTErrISR(COMPORT);
		I7565CPM_RemoveEMCYISR(COMPORT);

		m_comport.EnableWindow(TRUE);
		m_baud.EnableWindow(TRUE);
		m_node.EnableWindow(FALSE);

		m_btn_initial.ShowWindow(SW_SHOW);
		m_btn_shutdown.ShowWindow(SW_HIDE);

		m_btn_addnode.EnableWindow(FALSE);
		m_btn_addnode.ShowWindow(SW_SHOW);
		m_btn_removenode.EnableWindow(FALSE);
		m_btn_removenode.ShowWindow(SW_HIDE);

		Enable_Disable(FALSE);

		KillTimer(123);
	}
}

void CNMT_ProtocolDlg::OnButtonAddnode() 
{
	// TODO: Add your control notification handler code here
	ret = I7565CPM_AddNode(COMPORT, NODE, 1, DelayTime, 200, BlockMode);
	if(ret){
		errstr.Format(_T("AddNode Error, = %d"),ret);
		MessageBox(errstr,_T("Error"),MB_OK);
	}
	else{
		m_btn_addnode.EnableWindow(FALSE);
		m_btn_addnode.ShowWindow(SW_HIDE);
		m_btn_removenode.EnableWindow(TRUE);
		m_btn_removenode.ShowWindow(SW_SHOW);
		m_node.EnableWindow(FALSE);

		Enable_Disable(TRUE);
	}
}

void CNMT_ProtocolDlg::OnButtonRemove() 
{
	// TODO: Add your control notification handler code here
	ret = I7565CPM_RemoveNode(COMPORT, NODE, BlockMode);
	if(ret){
		errstr.Format(_T("RemoveNode Error, = %d"),ret);
		MessageBox(errstr,_T("Error"),MB_OK);
	}
	else{
		m_btn_addnode.EnableWindow(TRUE);
		m_btn_addnode.ShowWindow(SW_SHOW);
		m_btn_removenode.EnableWindow(FALSE);
		m_btn_removenode.ShowWindow(SW_HIDE);
		m_node.EnableWindow(TRUE);

		Enable_Disable(FALSE);
	}
}

void CNMT_ProtocolDlg::OnButtonSetstate() 
{
	CString DataStr;
	// TODO: Add your control notification handler code here
	ret = I7565CPM_NMTChangeState(COMPORT, NODE, STA, BlockMode);
	if(ret){
		errstr.Format(_T("Change Slave State Error, = %d"),ret);
		MessageBox(errstr,_T("Error"),MB_OK);
	}
	else{
		DataStr.Format(_T("Change Slave State to %s OK"),STA_Str);
		m_reslist.AddString(DataStr);
	}
}

void CNMT_ProtocolDlg::OnButtonGuarding() 
{
	CString DataStr, TempStr;
	WORD n_GuardTimer, n_LifeTime;
	wchar_t *endstr;
	// TODO: Add your control notification handler code here

	m_guardtime.GetWindowText(TempStr);
	n_GuardTimer = (WORD)wcstol(TempStr.AllocSysString(),&endstr,10);

	m_lifetime.GetWindowText(TempStr);
	n_LifeTime = (WORD)wcstol(TempStr.AllocSysString(),&endstr,10);

	ret = I7565CPM_NMTGuarding(COMPORT, NODE, n_GuardTimer, (BYTE)n_LifeTime, BlockMode);
	if(ret){
		errstr.Format(_T("Set Guarding Error, = %d"),ret);
		MessageBox(errstr,_T("Error"),MB_OK);
	}
	else{
		DataStr.Format(_T("Set Guarding OK"));
		m_reslist.AddString(DataStr);
	}
}

void CNMT_ProtocolDlg::OnButtonHeartbeat() 
{
	CString DataStr, TempStr;
	WORD n_Heartbeat, n_Consumer;
	wchar_t *endstr;
	// TODO: Add your control notification handler code here

	m_heartbeat.GetWindowText(TempStr);
	n_Heartbeat = (WORD)wcstol(TempStr.AllocSysString(),&endstr,10);

	m_consumer.GetWindowText(TempStr);
	n_Consumer = (WORD)wcstol(TempStr.AllocSysString(),&endstr,10);

	ret = I7565CPM_NMTHeartbeat(COMPORT, NODE, n_Heartbeat, n_Consumer, BlockMode);
	if(ret){
		errstr.Format(_T("Set Heartbeat Error, = %d"),ret);
		MessageBox(errstr,_T("Error"),MB_OK);
	}
	else{
		DataStr.Format(_T("Set Heartbeat OK"),STA_Str);
		m_reslist.AddString(DataStr);
	}
}

void CNMT_ProtocolDlg::OnButtonClear() 
{
	// TODO: Add your control notification handler code here
	m_reslist.ResetContent();
}

void CNMT_ProtocolDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	// TODO: Add your message handler code here
	I7565CPM_ShutdownMaster(COMPORT);
}

void CNMT_ProtocolDlg::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	if(NMTErr != ""){
		m_reslist.AddString(NMTErr);
		NMTErr = "";
	}

	if(EMCY != ""){
		m_reslist.AddString(EMCY);
		EMCY = "";
	}

	CDialog::OnTimer(nIDEvent);
}
