VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "PDO_MultiData"
   ClientHeight    =   4695
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   4455
   LinkTopic       =   "Form1"
   ScaleHeight     =   4695
   ScaleWidth      =   4455
   StartUpPosition =   3  'Windows Default
   Begin VB.Timer Timer1 
      Enabled         =   0   'False
      Interval        =   100
      Left            =   3840
      Top             =   3960
   End
   Begin VB.ListBox List_PDOData 
      Height          =   2400
      ItemData        =   "Form1.frx":0000
      Left            =   120
      List            =   "Form1.frx":0002
      TabIndex        =   13
      Top             =   2040
      Width           =   4215
   End
   Begin VB.CommandButton Btn_SetEventTimer 
      Caption         =   $"Form1.frx":0004
      Height          =   615
      Left            =   240
      TabIndex        =   11
      Top             =   1320
      Width           =   1695
   End
   Begin VB.CommandButton Btn_SetPolling 
      Caption         =   $"Form1.frx":0027
      Height          =   615
      Left            =   2520
      TabIndex        =   10
      Top             =   1320
      Width           =   1695
   End
   Begin VB.CommandButton Btn_AddNode 
      Caption         =   "Add Node"
      Height          =   375
      Left            =   2880
      TabIndex        =   9
      Top             =   840
      Width           =   1455
   End
   Begin VB.CommandButton Btn_Initial 
      Caption         =   "Initial Master"
      Height          =   375
      Left            =   2880
      TabIndex        =   8
      Top             =   360
      Width           =   1455
   End
   Begin VB.CommandButton Btn_Remove 
      Caption         =   "Remove Node"
      Height          =   375
      Left            =   2880
      TabIndex        =   4
      Top             =   840
      Width           =   1455
   End
   Begin VB.CommandButton Btn_Shutdown 
      Caption         =   "Shutdown"
      Height          =   375
      Left            =   2880
      TabIndex        =   3
      Top             =   360
      Width           =   1455
   End
   Begin VB.ComboBox Combo_Node 
      Height          =   315
      ItemData        =   "Form1.frx":004F
      Left            =   1080
      List            =   "Form1.frx":01D0
      TabIndex        =   2
      Top             =   840
      Width           =   1575
   End
   Begin VB.ComboBox Combo_Baud 
      Height          =   315
      ItemData        =   "Form1.frx":04BB
      Left            =   1080
      List            =   "Form1.frx":04D7
      TabIndex        =   1
      Top             =   480
      Width           =   1575
   End
   Begin VB.ComboBox Combo_Com 
      Height          =   315
      ItemData        =   "Form1.frx":053D
      Left            =   1080
      List            =   "Form1.frx":0571
      TabIndex        =   0
      Top             =   120
      Width           =   1575
   End
   Begin VB.Label Label4 
      Caption         =   "Or"
      Height          =   255
      Left            =   2160
      TabIndex        =   12
      Top             =   1560
      Width           =   255
   End
   Begin VB.Label Label3 
      Caption         =   "Node ID"
      Height          =   255
      Left            =   120
      TabIndex        =   7
      Top             =   840
      Width           =   615
   End
   Begin VB.Label Label2 
      Caption         =   "Baud Rate"
      Height          =   255
      Left            =   120
      TabIndex        =   6
      Top             =   480
      Width           =   855
   End
   Begin VB.Label Label1 
      Caption         =   "Com Port"
      Height          =   255
      Left            =   120
      TabIndex        =   5
      Top             =   120
      Width           =   735
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim COMPORT As Byte
Dim BAUD As Byte
Dim node As Byte

Const BlockMode As Byte = 1

Dim Id_List(10) As Integer
Dim PDO_Cnt As Byte

Dim DelayTime As Integer
Dim ret As Integer
Dim errstr As String
    
Private Sub Btn_AddNode_Click()
    ret = I7565CPM_AddNode(COMPORT, node, 1, DelayTime, 200, BlockMode)
    If (ret <> 0) Then
        errstr = "AddNode Error, = " + Str(ret)
        MsgBox (errstr)
    Else
        Btn_AddNode.Enabled = False
        Btn_AddNode.Visible = False
        Btn_Remove.Enabled = True
        Combo_Node.Enabled = False

        ret = I7565CPM_GetTxPDOID(COMPORT, node, PDO_Cnt, Id_List(0), BlockMode)
        If (ret <> 0) Then
            errstr = "GetTxPDOID Error, = " + Str(ret)
            MsgBox (errstr)

            Btn_SetEventTimer.Enabled = False
            Btn_SetPolling.Enabled = False
        Else
            Btn_SetEventTimer.Enabled = True
            Btn_SetPolling.Enabled = True
            Timer1.Enabled = True
        End If
    End If
End Sub

Private Sub Btn_Initial_Click()
    ret = I7565CPM_InitMaster(COMPORT, 0, BAUD, BlockMode)
    If (ret <> 0) Then
        errstr = "Initial Error, = " + Str(ret)
        MsgBox (errstr)
    Else
        Combo_Com.Enabled = False
        Combo_Baud.Enabled = False
        Combo_Node.Enabled = True

        Btn_Initial.Enabled = False
        Btn_Initial.Visible = False
        Btn_Shutdown.Enabled = True

        Btn_AddNode.Enabled = True
        Btn_AddNode.Visible = True
    End If
End Sub

Private Sub Btn_Remove_Click()
    ret = I7565CPM_RemoveNode(COMPORT, node, BlockMode)
    If (ret <> 0) Then
        errstr = "RemoveNode Error, = " + Str(ret)
        MsgBox (errstr)
    Else
        Btn_AddNode.Enabled = True
        Btn_AddNode.Visible = True
        Btn_Remove.Enabled = False
        Combo_Node.Enabled = True

        Btn_SetEventTimer.Enabled = False
        Btn_SetPolling.Enabled = False

        Timer1.Enabled = False
    End If
End Sub

Private Sub Btn_SetEventTimer_Click()
    Dim i As Integer
    Dim Temp_Str As String
    Dim CobId(0) As Integer

    ret = I7565CPM_SetPDORemotePolling(COMPORT, 0, CobId(0), 0, BlockMode)  ' Remove PDO-Polling
    If (ret <> 0) Then
        Temp_Str = "Stop TxPDO Polling Error, = " + Str(ret)
        MsgBox (Temp_Str)
    End If

    If PDO_Cnt <> 0 Then
        For i = 0 To PDO_Cnt - 1
            ret = I7565CPM_PDOEventTimer(COMPORT, Id_List(i), 500, BlockMode)
            If (ret <> 0) Then
                Temp_Str = "The PDO " + Hex(Id_List(i)) + " Not Support Event Timer"
                MsgBox (Temp_Str)
            End If
        Next i
    End If
End Sub

Private Sub Btn_SetPolling_Click()
    Dim i As Integer
    Dim Temp_Str As String

    If PDO_Cnt <> 0 Then
        For i = 0 To PDO_Cnt - 1
            ret = I7565CPM_PDOEventTimer(COMPORT, Id_List(i), 0, BlockMode)   ' Stop PDO Event Timer
            If (ret <> 0) Then
                Temp_Str = "Stop The PDO " + Hex(Id_List(i)) + " Event Timer Error, = " + Str(ret)
                MsgBox (Temp_Str)
            End If
        Next i
    End If

    ret = I7565CPM_SetPDORemotePolling(COMPORT, PDO_Cnt, Id_List(0), 100, BlockMode)
    If (ret <> 0) Then
        Temp_Str = "Set Polling All TxPDO Error, = " + Str(ret)
        MsgBox (Temp_Str)
    End If
End Sub

Private Sub Btn_Shutdown_Click()
    ret = I7565CPM_ShutdownMaster(COMPORT)
    If (ret <> 0) Then
        errstr = "Shutdown Error, = " + Str(ret)
        MsgBox (errstr)
    Else
        Combo_Com.Enabled = True
        Combo_Baud.Enabled = True
        Combo_Node.Enabled = False

        Btn_Initial.Enabled = True
        Btn_Initial.Visible = True
        Btn_Shutdown.Enabled = False

        Btn_AddNode.Enabled = False
        Btn_AddNode.Visible = True
        Btn_Remove.Enabled = False

        Btn_SetEventTimer.Enabled = False
        Btn_SetPolling.Enabled = False

        Timer1.Enabled = False
    End If
End Sub

Private Sub Combo_Baud_LostFocus()
    BAUD = Combo_Baud.ListIndex
    
    Select Case (BAUD)
        Case 0
            DelayTime = 15
        Case 1
            DelayTime = 7
        Case 2
            DelayTime = 3
        Case 3
        Case 4
            DelayTime = 1
        Case 5
        Case 6
        Case 7
            DelayTime = 0
    End Select
End Sub

Private Sub Combo_Com_LostFocus()
    COMPORT = (Combo_Com.ListIndex)
End Sub

Private Sub Combo_Node_LostFocus()
    node = Combo_Node.ListIndex + 1
End Sub

Private Sub Form_Load()
    COMPORT = 0
    BAUD = 0
    node = 1

    Combo_Com.Enabled = True
    Combo_Baud.Enabled = True
    Combo_Node.Enabled = False

    Combo_Com.ListIndex = 0
    Combo_Baud.ListIndex = 0
    Combo_Node.ListIndex = 0

    Btn_AddNode.Enabled = False
    Btn_AddNode.Visible = True
    Btn_Remove.Enabled = False
    Btn_SetEventTimer.Enabled = False
    Btn_SetPolling.Enabled = False
End Sub

Private Sub Form_Unload(Cancel As Integer)
    I7565CPM_ShutdownMaster (COMPORT)
End Sub

Private Sub Timer1_Timer()
    Dim i As Integer, j As Integer
    Dim Temp_Str As String

    Dim IsNew() As Byte
    Dim DLen() As Byte
    Dim data() As Byte
    
    ReDim IsNew(PDO_Cnt)
    ReDim DLen(PDO_Cnt)
    ReDim data(8 * PDO_Cnt)
    
    ret = I7565CPM_GetMultiPDOData(COMPORT, PDO_Cnt, Id_List(0), IsNew(0), DLen(0), data(0), 0)
    If (ret = 0) Then
        Dim totallen As Integer

        totallen = 0
        
        Call List_PDOData.Clear

        If PDO_Cnt <> 0 Then
            For i = 0 To PDO_Cnt - 1
                Temp_Str = "TxPDO " + Hex(Id_List(i)) + " : "

                If DLen(i) <> 0 Then
                    For j = 0 To DLen(i) - 1
                        Temp_Str = Temp_Str + Hex(data(j + totallen)) + " "
                    Next j
                End If

                totallen = totallen + DLen(i)

                List_PDOData.AddItem (Temp_Str)
            Next i
        End If
    End If
End Sub
