// PDO_ProtocolDlg.h : header file
//

#if !defined(AFX_PDO_PROTOCOLDLG_H__A4B295AD_45DB_47AC_9600_1D2331AD30C5__INCLUDED_)
#define AFX_PDO_PROTOCOLDLG_H__A4B295AD_45DB_47AC_9600_1D2331AD30C5__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CPDO_ProtocolDlg dialog

class CPDO_ProtocolDlg : public CDialog
{
// Construction
public:
	CPDO_ProtocolDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CPDO_ProtocolDlg)
	enum { IDD = IDD_PDO_PROTOCOL_DIALOG };
	CListBox	m_pdolist;
	CEdit	m_d7;
	CEdit	m_d6;
	CEdit	m_d5;
	CEdit	m_d4;
	CEdit	m_d3;
	CEdit	m_d2;
	CEdit	m_d1;
	CEdit	m_d0;
	CEdit	m_cobid;
	CComboBox	m_node;
	CComboBox	m_len;
	CComboBox	m_comport;
	CComboBox	m_baud;
	CButton	m_btn_shutdown;
	CButton	m_btn_removenode;
	CButton	m_btn_pdow;
	CButton	m_btn_pdor;
	CButton	m_btn_initial;
	CButton	m_btn_clear;
	CButton	m_btn_addnode;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CPDO_ProtocolDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;
	void Enable_Disable(bool Sta);
	// Generated message map functions
	//{{AFX_MSG(CPDO_ProtocolDlg)
	virtual BOOL OnInitDialog();
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnSelchangeComboCom();
	afx_msg void OnSelchangeComboBaud();
	afx_msg void OnSelchangeComboNode();
	afx_msg void OnButtonInitial();
	afx_msg void OnButtonShutdown();
	afx_msg void OnButtonAddnode();
	afx_msg void OnButtonRemove();
	afx_msg void OnButtonClear();
	afx_msg void OnSelchangeComboLen();
	afx_msg void OnButtonPdow();
	afx_msg void OnButtonPdor();
	afx_msg void OnDestroy();
	afx_msg void OnTimer(UINT nIDEvent);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_PDO_PROTOCOLDLG_H__A4B295AD_45DB_47AC_9600_1D2331AD30C5__INCLUDED_)
