VERSION 5.00
Begin VB.Form Btn_ScanNode 
   Caption         =   "Scan_Node"
   ClientHeight    =   4335
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   4335
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin VB.ListBox List_NodeList 
      Height          =   1815
      ItemData        =   "Form1.frx":0000
      Left            =   120
      List            =   "Form1.frx":0002
      TabIndex        =   11
      Top             =   2280
      Width           =   4455
   End
   Begin VB.CommandButton Btn_ScanNode 
      Caption         =   "Scan Node"
      Height          =   375
      Left            =   2880
      TabIndex        =   10
      Top             =   840
      Width           =   1455
   End
   Begin VB.CommandButton Btn_Initial 
      Caption         =   "Initial Master"
      Height          =   375
      Left            =   2880
      TabIndex        =   9
      Top             =   360
      Width           =   1455
   End
   Begin VB.CommandButton Btn_Remove 
      Caption         =   "Remove Node"
      Height          =   375
      Left            =   2880
      TabIndex        =   5
      Top             =   1800
      Width           =   1455
   End
   Begin VB.CommandButton Btn_Shutdown 
      Caption         =   "Shutdown"
      Height          =   375
      Left            =   2880
      TabIndex        =   4
      Top             =   360
      Width           =   1455
   End
   Begin VB.ComboBox Combo_Node 
      Height          =   315
      ItemData        =   "Form1.frx":0004
      Left            =   1080
      List            =   "Form1.frx":0185
      TabIndex        =   3
      Top             =   1320
      Width           =   1575
   End
   Begin VB.ComboBox Combo_Baud 
      Height          =   315
      ItemData        =   "Form1.frx":0470
      Left            =   1080
      List            =   "Form1.frx":048C
      TabIndex        =   2
      Top             =   480
      Width           =   1575
   End
   Begin VB.ComboBox Combo_Com 
      Height          =   315
      ItemData        =   "Form1.frx":04F2
      Left            =   1080
      List            =   "Form1.frx":0526
      TabIndex        =   1
      Top             =   120
      Width           =   1575
   End
   Begin VB.CommandButton Btn_AddNode 
      Caption         =   "Add Node"
      Height          =   375
      Left            =   2880
      TabIndex        =   0
      Top             =   1320
      Width           =   1455
   End
   Begin VB.Label Label4 
      Caption         =   "Master Node List"
      Height          =   255
      Left            =   120
      TabIndex        =   12
      Top             =   1920
      Width           =   1335
   End
   Begin VB.Label Label3 
      Caption         =   "Node ID"
      Height          =   255
      Left            =   120
      TabIndex        =   8
      Top             =   1320
      Width           =   615
   End
   Begin VB.Label Label2 
      Caption         =   "Baud Rate"
      Height          =   255
      Left            =   120
      TabIndex        =   7
      Top             =   480
      Width           =   855
   End
   Begin VB.Label Label1 
      Caption         =   "Com Port"
      Height          =   255
      Left            =   120
      TabIndex        =   6
      Top             =   120
      Width           =   735
   End
End
Attribute VB_Name = "Btn_ScanNode"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim COMPORT As Byte
Dim BAUD As Byte
Dim node As Byte

Const BlockMode As Byte = 1

Dim NODE_CNT As Byte

Dim DelayTime As Integer
Dim ret As Integer
Dim errstr As String

Private Sub Btn_AddNode_Click()
        Dim NodeList(16) As Byte
        Dim Temp_Node As Byte
        Dim i As Integer, j As Integer, Flag As Integer
        Dim NodeNumber As String


    ret = I7565CPM_AddNode(COMPORT, node, 1, DelayTime, 200, BlockMode)
    If ret <> 0 Then
        errstr = "AddNode Error, = " + Str(ret)
        MsgBox (errstr)
    Else
        Temp_Node = 0
        Flag = 0
        
        ret = I7565CPM_GetNodeList(COMPORT, NodeList(0), BlockMode)
        If ret <> 0 Then
            errstr = "Node List Get Error, = " + Str(ret)
            MsgBox (errstr)
        Else
            Call List_NodeList.Clear
            ' NodeList[0] is node 0 ~ 7
            ' NodeList[1] is node 8 ~ 15
            ' ...
            ' NodeList[15] is node 120 ~ 127

            For i = 0 To 15
                Flag = 1

                For j = 0 To 7
                    If (NodeList(i) And Flag) <> 0 Then
                        NodeNumber = "Node " + Right("000" + Trim(Str(Temp_Node)), 3) + " under controll"
                        List_NodeList.AddItem (NodeNumber)
                    End If

                    Temp_Node = Temp_Node + 1
                    Flag = Flag * 2
                Next
            Next
        End If
    End If
End Sub

Private Sub Btn_Initial_Click()

    ret = I7565CPM_InitMaster(COMPORT, 0, BAUD, BlockMode)
    If ret <> 0 Then
        errstr = "Initial Error, = " + Str(ret)
        MsgBox (errstr)
    Else
        Combo_Com.Enabled = False
        Combo_Baud.Enabled = False
        Combo_Node.Enabled = True

        Btn_Initial.Enabled = False
        Btn_Initial.Visible = False
        Btn_Shutdown.Enabled = True

        Btn_AddNode.Enabled = True
        Btn_Remove.Enabled = True
        Btn_ScanNode.Enabled = True
    End If
End Sub

Private Sub Btn_Remove_Click()
    Dim NodeList(16) As Byte
    Dim Temp_Node As Byte
    Dim i As Integer, j As Integer, Flag As Integer
    Dim NodeNumber As String

    ret = I7565CPM_RemoveNode(COMPORT, node, BlockMode)
     If ret <> 0 Then
         errstr = "RemoveNode Error, = " + Str(ret)
         MsgBox (errstr)
     Else
        Temp_Node = 0
        Flag = 0
        
         ret = I7565CPM_GetNodeList(COMPORT, NodeList(0), BlockMode)
         If ret <> 0 Then
             errstr = "Node List Get Error, = " + Str(ret)
             MsgBox (errstr)
         Else
             Call List_NodeList.Clear
             ' NodeList[0] is node 0 ~ 7
             ' NodeList[1] is node 8 ~ 15
             ' ...
             ' NodeList[15] is node 120 ~ 127

             For i = 0 To 15
                 Flag = 1

                 For j = 0 To 7
                     If (NodeList(i) And Flag) <> 0 Then
                         NodeNumber = "Node " + Right("000" + Trim(Str(Temp_Node)), 3) + " under controll"
                         List_NodeList.AddItem (NodeNumber)
                     End If

                     Temp_Node = Temp_Node + 1
                     Flag = Flag * 2
                 Next
             Next
         End If
     End If
End Sub

Private Sub Btn_ScanNode_Click()
    Dim NodeList(16) As Byte
    Dim Temp_Node As Byte
    Dim i As Integer, j As Integer, Flag As Integer
    Dim NodeNumber As String

    Temp_Node = 0
    Flag = 0
    
    ' Set function timeout to 3000 ms
    Call I7565CPM_SetFunctionTimeout(COMPORT, 5000)

    ' Scan total node to check witch nodes are on the CANopen bus
    ret = I7565CPM_ScanNode(COMPORT, 0, 0, NodeList(0), BlockMode)
    If ret <> 0 Then
        errstr = "Node Scan Error, = " + Str(ret)
        MsgBox (errstr)
    Else
        ' Set function timeout to 1000 ms (default value)
        Call I7565CPM_SetFunctionTimeout(COMPORT, 3000)

        Call Combo_Node.Clear
        ' NodeList[0] is node 0 ~ 7
        ' NodeList[1] is node 8 ~ 15
        ' ...
        ' NodeList[15] is node 120 ~ 127

        For i = 0 To 15
            Flag = 1

            For j = 0 To 7
                If (NodeList(i) And Flag) <> 0 Then
                    NodeNumber = Right("000" + Trim(Str(Temp_Node)), 3)
                    Combo_Node.AddItem (NodeNumber)
                    NODE_CNT = NODE_CNT + 1
                End If

                Temp_Node = Temp_Node + 1
                Flag = Flag * 2
            Next
        Next

        If Combo_Node.ListCount <> 0 Then
            Combo_Node.Enabled = True
            Btn_AddNode.Enabled = True
            Btn_Remove.Enabled = True
        Else
            Combo_Node.AddItem ("None Slave!")

            Combo_Node.Enabled = False
            Btn_AddNode.Enabled = False
            Btn_Remove.Enabled = False

            node = 0
        End If

        Combo_Node.ListIndex = 0
    End If
End Sub

Private Sub Btn_Shutdown_Click()

    ret = I7565CPM_ShutdownMaster(COMPORT)
    If ret <> 0 Then
        errstr = "Shutdown Error, = " + Str(ret)
        MsgBox (errstr)
    Else
        Combo_Com.Enabled = True
        Combo_Baud.Enabled = True
        Combo_Node.Enabled = False

        Btn_Initial.Enabled = True
        Btn_Initial.Visible = True
        Btn_Shutdown.Enabled = False

        Btn_AddNode.Enabled = False
        Btn_Remove.Enabled = False
        Btn_ScanNode.Enabled = False
    End If
End Sub

Private Sub Combo_Baud_LostFocus()
    BAUD = Combo_Baud.ListIndex
    
    Select Case (BAUD)
        Case 0
            DelayTime = 15
        Case 1
            DelayTime = 7
        Case 2
            DelayTime = 3
        Case 3
        Case 4
            DelayTime = 1
        Case 5
        Case 6
        Case 7
            DelayTime = 0
    End Select
End Sub

Private Sub Combo_Com_LostFocus()
    COMPORT = (Combo_Com.ListIndex)
End Sub

Private Sub Combo_Node_LostFocus()
    node = Combo_Node.ListIndex + 1
End Sub

Private Sub Form_Load()
    COMPORT = 0
    BAUD = 0
    node = 1
    NODE_CNT = 0

    Combo_Com.Enabled = True
    Combo_Baud.Enabled = True
    Combo_Node.Enabled = False

    Combo_Com.ListIndex = 0
    Combo_Baud.ListIndex = 0

    Btn_AddNode.Enabled = False
    Btn_Remove.Enabled = False
    Btn_ScanNode.Enabled = False

End Sub

Private Sub Form_Unload(Cancel As Integer)
    I7565CPM_ShutdownMaster (COMPORT)
End Sub

