// Scan_NodeDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Scan_Node.h"
#include "Scan_NodeDlg.h"
#include "..\lib\i7565cpm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CScan_NodeDlg dialog

CScan_NodeDlg::CScan_NodeDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CScan_NodeDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CScan_NodeDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CScan_NodeDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CScan_NodeDlg)
	DDX_Control(pDX, IDC_LIST_NODELIST, m_nodelist);
	DDX_Control(pDX, IDC_COMBO_NODE, m_node);
	DDX_Control(pDX, IDC_COMBO_COM, m_comport);
	DDX_Control(pDX, IDC_COMBO_BAUD, m_baud);
	DDX_Control(pDX, IDC_BUTTON_SHUTDOWN, m_btn_shutdown);
	DDX_Control(pDX, IDC_BUTTON_SCAN, m_btn_scan);
	DDX_Control(pDX, IDC_BUTTON_REMOVE, m_btn_removenode);
	DDX_Control(pDX, IDC_BUTTON_INITIAL, m_btn_initial);
	DDX_Control(pDX, IDC_BUTTON_ADDNODE, m_btn_addnode);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CScan_NodeDlg, CDialog)
	//{{AFX_MSG_MAP(CScan_NodeDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_CBN_SELCHANGE(IDC_COMBO_COM, OnSelchangeComboCom)
	ON_CBN_SELCHANGE(IDC_COMBO_BAUD, OnSelchangeComboBaud)
	ON_CBN_SELCHANGE(IDC_COMBO_NODE, OnSelchangeComboNode)
	ON_BN_CLICKED(IDC_BUTTON_INITIAL, OnButtonInitial)
	ON_BN_CLICKED(IDC_BUTTON_SHUTDOWN, OnButtonShutdown)
	ON_BN_CLICKED(IDC_BUTTON_SCAN, OnButtonScan)
	ON_BN_CLICKED(IDC_BUTTON_ADDNODE, OnButtonAddnode)
	ON_BN_CLICKED(IDC_BUTTON_REMOVE, OnButtonRemove)
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CScan_NodeDlg message handlers

BYTE COMPORT=0;
BYTE BAUD=0;
BYTE NODE=0;

BYTE BlockMode = 1;

WORD DelayTime=0;
WORD ret;
CString errstr;

BOOL CScan_NodeDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	// TODO: Add extra initialization here

	m_comport.EnableWindow(TRUE);
	m_baud.EnableWindow(TRUE);
	m_node.EnableWindow(FALSE);

	m_btn_shutdown.EnableWindow(FALSE);
	m_btn_shutdown.ShowWindow(SW_HIDE);
	m_btn_initial.EnableWindow(TRUE);
	m_btn_initial.ShowWindow(SW_SHOW);
	
	m_btn_scan.EnableWindow(FALSE);
	m_btn_addnode.EnableWindow(FALSE);
	m_btn_removenode.EnableWindow(FALSE);

	m_comport.SetCurSel(0);
	m_baud.SetCurSel(0);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CScan_NodeDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CScan_NodeDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CScan_NodeDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CScan_NodeDlg::OnSelchangeComboCom() 
{
	// TODO: Add your control notification handler code here
	COMPORT = m_comport.GetCurSel();
}

void CScan_NodeDlg::OnSelchangeComboBaud() 
{
	// TODO: Add your control notification handler code here
	BAUD = m_baud.GetCurSel();

	switch(BAUD){
	case 0:
		DelayTime = 15;
		break;
	case 1:
		DelayTime = 7;
		break;
	case 2:
		DelayTime = 3;
		break;
	case 3:
	case 4:
		DelayTime = 1;
		break;
	case 5:
	case 6:
	case 7:
		DelayTime = 0;
		break;
	}
}

void CScan_NodeDlg::OnSelchangeComboNode() 
{
	WORD Node_Index;
	char T_TempStr[10];
	char *end_str;
	// TODO: Add your control notification handler code here

	if(!m_node.GetCount()) return;

	Node_Index = m_node.GetCurSel();

	// Convert text to Node ID number
	m_node.GetLBText(Node_Index,T_TempStr);
	NODE = (BYTE)strtoul(T_TempStr,&end_str,10);
}

void CScan_NodeDlg::OnButtonInitial() 
{
	// TODO: Add your control notification handler code here
	ret = I7565CPM_InitMaster(COMPORT, 0, BAUD, BlockMode);
	if(ret){
		errstr.Format(_T("Initial Error, = %d"),ret);
		MessageBox(errstr,_T("Error"),MB_OK);
	}
	else{
		m_comport.EnableWindow(FALSE);
		m_baud.EnableWindow(FALSE);

		m_btn_initial.EnableWindow(FALSE);
		m_btn_initial.ShowWindow(SW_HIDE);
		m_btn_shutdown.EnableWindow(TRUE);
		m_btn_shutdown.ShowWindow(SW_SHOW);

		m_btn_scan.EnableWindow(TRUE);
	}
}

void CScan_NodeDlg::OnButtonShutdown() 
{
	// TODO: Add your control notification handler code here
	ret = I7565CPM_ShutdownMaster(COMPORT);
	if(ret){
		errstr.Format(_T("Shutdown Error, = %d"),ret);
		MessageBox(errstr,_T("Error"),MB_OK);
	}
	else{
		m_comport.EnableWindow(TRUE);
		m_baud.EnableWindow(TRUE);
		m_node.EnableWindow(FALSE);

		m_btn_initial.EnableWindow(TRUE);
		m_btn_initial.ShowWindow(SW_SHOW);
		m_btn_shutdown.EnableWindow(FALSE);
		m_btn_shutdown.ShowWindow(SW_HIDE);

		m_btn_scan.EnableWindow(FALSE);
		m_btn_addnode.EnableWindow(FALSE);
		m_btn_removenode.EnableWindow(FALSE);
	}
}

void CScan_NodeDlg::OnButtonAddnode() 
{
	// TODO: Add your control notification handler code here
	ret = I7565CPM_AddNode(COMPORT, NODE, 1, DelayTime, 200, BlockMode);
	if(ret){
		errstr.Format(_T("AddNode Error, = %d"),ret);
		MessageBox(errstr,_T("Error"),MB_OK);
	}
	else{
		BYTE NodeList[16];
		BYTE Flag, Node=0;
		WORD i,j;
		CString NodeNumber;

		ret = I7565CPM_GetNodeList(COMPORT, NodeList, BlockMode);
		if(ret){
			errstr.Format(_T("Node List Get Error, = %d"),ret);
			MessageBox(errstr,_T("Error"),MB_OK);
		}
		else{
			m_nodelist.ResetContent();
			// NodeList[0] is node 0 ~ 7
			// NodeList[1] is node 8 ~ 15
			// ...
			// NodeList[15] is node 120 ~ 127
			for(i=0;i<16;i++){
				Flag=1;
				for(j=0;j<8;j++){
					if(NodeList[i] & Flag){
						NodeNumber.Format(_T("Node %03d under controll"),Node);
						m_nodelist.AddString(NodeNumber);
					}
					Node++;
					Flag = Flag << 1;
				}
			}
		}
	}
}

void CScan_NodeDlg::OnButtonRemove() 
{
	// TODO: Add your control notification handler code here
	ret = I7565CPM_RemoveNode(COMPORT, NODE, BlockMode);
	if(ret){
		errstr.Format(_T("RemoveNode Error, = %d"),ret);
		MessageBox(errstr,_T("Error"),MB_OK);
	}
	else{
		BYTE NodeList[16];
		BYTE Flag, Node=0;
		WORD i,j;
		CString NodeNumber;

		ret = I7565CPM_GetNodeList(COMPORT, NodeList, BlockMode);
		if(ret){
			errstr.Format(_T("Node List Get Error, = %d"),ret);
			MessageBox(errstr,_T("Error"),MB_OK);
		}
		else{
			m_nodelist.ResetContent();
			// NodeList[0] is node 0 ~ 7
			// NodeList[1] is node 8 ~ 15
			// ...
			// NodeList[15] is node 120 ~ 127
			for(i=0;i<16;i++){
				Flag=1;
				for(j=0;j<8;j++){
					if(NodeList[i] & Flag){
						NodeNumber.Format(_T("Node %03d under controll"),Node);
						m_nodelist.AddString(NodeNumber);
					}
					Node++;
					Flag = Flag << 1;
				}
			}
		}
	}
}

void CScan_NodeDlg::OnButtonScan() 
{
	BYTE NodeList[16];
	BYTE Flag, Node=0;
	WORD i,j;
	CString NodeNumber;
	// TODO: Add your control notification handler code here

	// Set function timeout to 3000 ms
	I7565CPM_SetFunctionTimeout(COMPORT, 3000);

	// Scan total node to check witch nodes are on the CANopen bus
	ret = I7565CPM_ScanNode(COMPORT, 0, 0, NodeList, BlockMode);
	if(ret){
		errstr.Format(_T("Node Scan Error, = %d"),ret);
		MessageBox(errstr,_T("Error"),MB_OK);
	}
	else{
		// Set function timeout to 1000 ms (default value)
		I7565CPM_SetFunctionTimeout(COMPORT, 1000);

		m_node.ResetContent();
		// NodeList[0] is node 0 ~ 7
		// NodeList[1] is node 8 ~ 15
		// ...
		// NodeList[15] is node 120 ~ 127
		for(i=0;i<16;i++){
			Flag=1;
			for(j=0;j<8;j++){
				if(NodeList[i] & Flag){
					NodeNumber.Format(_T("%03d"),Node);
					m_node.AddString(NodeNumber);
				}
				Node++;
				Flag = Flag << 1;
			}
		}

		if(m_node.GetCount()){
			char T_TempStr[10];
			char *end_str;

			m_node.EnableWindow(TRUE);
			m_btn_addnode.EnableWindow(TRUE);
			m_btn_removenode.EnableWindow(TRUE);

			// Convert text to Node ID number
			m_node.GetLBText(0,T_TempStr);
			NODE = (BYTE)strtoul(T_TempStr,&end_str,10);
		}
		else{
			m_node.AddString(_T("None Slave!"));
			m_node.EnableWindow(FALSE);
			m_btn_addnode.EnableWindow(FALSE);
			m_btn_removenode.EnableWindow(FALSE);

			NODE = 0;
		}

		m_node.SetCurSel(0);
	}
}

void CScan_NodeDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	// TODO: Add your message handler code here
	I7565CPM_ShutdownMaster(COMPORT);
}
